﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Microsoft.Win32;

namespace Softwares
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            string strDispName = null;
            string strTemp1 = null;
            string strTemp2 = null;
            string strTemp3 = null;
            string strTemp4 = null;

            DateTime dtScanDate = new DateTime();
            DataTable dtData = new DataTable();
            dtData.Columns.Add("Name", typeof(string));
            dtData.Columns.Add("Version", typeof(string));
            dtData.Columns.Add("Publisher", typeof(string));
            DataRow drData = null;

            string SoftwareKey = "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\UnInstall";

            
            using (RegistryKey rkRegistryKeyOne = Registry.LocalMachine.OpenSubKey(SoftwareKey))
            {
                foreach (var varName in rkRegistryKeyOne.GetSubKeyNames())
                {
                    using (RegistryKey rkRegistryKeyTwo = rkRegistryKeyOne.OpenSubKey(varName))
                    {
                        strDispName = Convert.ToString(rkRegistryKeyTwo.GetValue("DisplayName"));
                        if (strDispName.Equals(""))
                        {
                            continue;
                        }
                        else
                        {
                            strTemp1 = Convert.ToString(rkRegistryKeyTwo.GetValue("InstallDate"));
                            if (strTemp1.Equals(""))
                            {
                               

                            }
                            else
                            {
                                //dtScanDate = Convert.ToDateTime(rkRegistryKeyTwo.GetValue("InstallDate").ToString());
                                strTemp2 = strTemp1.Substring(0, 4);
                                strTemp3 = strTemp1.Substring(4, 2);
                                strTemp4 = strTemp1.Substring(6, 2);
                                //strDate = strTemp4 + "-" + strTemp3 + "-" + strTemp2;
                                dtScanDate = new DateTime(Convert.ToInt32(strTemp2), Convert.ToInt32(strTemp3), Convert.ToInt32(strTemp4));
                               
                            }

                            drData = dtData.NewRow();
                            drData[0] = (string)rkRegistryKeyTwo.GetValue("DisplayName");
                            if (rkRegistryKeyTwo.GetValue("DisplayVersion") == null)
                                drData[1] = "";
                            else
                                drData[1] = (string)rkRegistryKeyTwo.GetValue("DisplayVersion");
                            drData[2] = (string)rkRegistryKeyTwo.GetValue("Publisher");
                            dtData.Rows.Add(drData);
                        }
                    }

                }
            }
            DgvSoftwareList.Columns.Clear();
            DgvSoftwareList.DataSource = dtData;
        }
    }
}
